<script lang="ts">
import { defineComponent, PropType } from 'vue';
import { CtfTheSourceArticlePage } from '~/models';
import {
  MrktoForm,
  OneTrustTroubleWarning,
} from '~/components/common/index.vue';
import { THE_SOURCE_TYPES } from '~/common/constants';

export default defineComponent({
  name: 'TheSourceForm',
  components: { OneTrustTroubleWarning, MrktoForm },
  props: {
    article: {
      type: Object as PropType<CtfTheSourceArticlePage>,
      required: true,
    },
  },
  data() {
    return {
      types: THE_SOURCE_TYPES,
      submitted: false,
    };
  },
  computed: {
    articleImage() {
      return (
        this.article.formImage && {
          src: this.article.formImage.fields?.file?.url,
          alt: this.article.formImage.fields?.file?.title,
        }
      );
    },
    formId() {
      if (this.article.type === THE_SOURCE_TYPES.WEBINAR) {
        const currentDate = new Date();
        const articleDate = new Date(this.article.date);

        return currentDate > articleDate ? '2076' : '1592';
      }

      return `${this.article.gatedAsset?.fields.formId}`;
    },
    webinarDate() {
      const currentDate = new Date();
      const date = new Date(this.article.date);
      if (
        this.article.type === THE_SOURCE_TYPES.WEBINAR &&
        date > currentDate
      ) {
        const options = { hour: 'numeric', minute: '2-digit', hour12: true };

        const ptTime = `${date.toLocaleString('en-US', { ...options, timeZone: 'America/Los_Angeles' })} PT`;
        const utcTime = `${date.toLocaleString('en-US', { ...options, timeZone: 'UTC' })} UTC`;

        const month = date.toLocaleString('en-US', { month: 'long' });
        const day = date.getUTCDate();
        const year = date.getFullYear();

        return {
          date: `${month} ${day}, ${year}`,
          time: `${ptTime} / ${utcTime}`,
        };
      }

      return null;
    },
  },
  methods: {
    onFormSubmit(email: string) {
      this.$emit('submit');
      this.submitted = true;

      if (this.article.type === THE_SOURCE_TYPES.GUIDE) {
        const { gatedAssetLink, utmCampaign } = this.article.gatedAsset.fields;
        const emailParam = `lb_email=${email}`;
        const utmCampaignParam = `utm_campaign=${utmCampaign}`;

        window.location.href = `${gatedAssetLink}?${emailParam}&${utmCampaignParam}`;
      }
    },
  },
});
</script>

<template>
  <div>
    <SlpTypography
      v-if="article.type === types.GUIDE"
      tag="h2"
      variant="heading5-bold"
      class="slp-mb-24"
      >{{ $t('articles.formHeader') }}
    </SlpTypography>
    <div class="ts-form-container">
      <div class="ts-form-container__info">
        <SlpTypography
          v-if="article.type === types.GUIDE"
          tag="h4"
          variant="all-caps"
          class="slp-mb-24"
          >{{ $t('articles.resources') }}</SlpTypography
        >
        <div v-if="articleImage" class="ts-form-container__image">
          <img v-bind="articleImage" />
        </div>
        <div v-if="article.type === types.WEBINAR" class="slp-flex slp-mt-16">
          <SlpIcon name="lock" variant="product" class="slp-mr-4" />
          <SlpTypography tag="h4" variant="all-caps">{{
            $t('articles.webinar')
          }}</SlpTypography>
        </div>
        <SlpTypography tag="h2" variant="heading4-bold" class="slp-mb-8"
          >{{ article.headline }}
        </SlpTypography>
        <div
          v-if="webinarDate"
          class="slp-flex slp-align-items-center slp-mb-8"
        >
          <SlpTypography variant="body3" tag="span">{{
            webinarDate.date
          }}</SlpTypography>
          <span class="separator" />
          <SlpTypography variant="body3" tag="span">{{
            webinarDate.time
          }}</SlpTypography>
        </div>
      </div>
      <div v-show="!submitted">
        <MrktoForm
          :data="{
            formId,
            all_required: false,
            datalayer: 'thesource',
          }"
          @submit-success="onFormSubmit"
        />
        <OneTrustTroubleWarning />
      </div>
      <div v-show="submitted" class="ts-form-container__submitted">
        <SlpIcon
          :name="webinarDate ? 'tick-circle' : 'laptop-video'"
          variant="marketing"
          class="slp-mr-4 slp-mb-8"
          size="xl"
        />
        <SlpTypography tag="h2" variant="heading4-bold" class="slp-mb-8">
          {{
            $t(
              `articles.${webinarDate ? 'formSubmittedHeader' : 'formSubmittedWebinarHeader'}`,
            )
          }}
        </SlpTypography>
        <SlpTypography tag="h2" variant="heading5" class="slp-mb-16">
          {{ $t(`articles.formSubmittedDescription`) }}
        </SlpTypography>
        <SlpButton
          v-if="article.type === types.WEBINAR && article.gatedAsset"
          :href="article.gatedAsset.fields.gatedAssetLink"
          variant="primary"
          >{{ $t('articles.watch') }}</SlpButton
        >
      </div>
    </div>
  </div>
</template>

<style scoped lang="scss">
.ts-form-container {
  background-color: $color-surface-100;
  border-radius: 8px;
  padding: $spacing-24;

  &__image {
    img {
      border-radius: 8px;
      width: 100%;
    }
  }

  &__info {
    border-bottom: 1px solid $color-surface-300;
    padding-bottom: $spacing-24;
    margin-bottom: $spacing-24;
  }

  &__submitted {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    min-height: 420px;
    text-align: center;
  }

  &:deep {
    .form_column .form_container {
      background: $color-surface-100;
      border: none;
      padding: 0;
    }

    #LblCountry {
      margin-top: 0 !important;
    }

    .form_column.slp-px-md-32 {
      padding-left: 0 !important;
      padding-right: 0 !important;
    }

    .form_column {
      padding: 0 !important;
    }

    .mktoForm_container {
      @media (min-width: $breakpoint-lg) {
        display: grid;
        grid-template-columns: 1fr 1fr;
        column-gap: 30px;
        .mktoFormRow:nth-of-type(11) {
          grid-column: 1/3;
        }
        .mktoButtonRow {
          grid-column: 1/3;
        }
      }
    }
  }
}
</style>
